//ged report 2 
//tested against Ftree, EasyTree, and others
//2.0.0.0  initial release ov version 2
//2.0.0.1  fixes unwanted characters in record,
//         fixes confusion between dest and deat
//2.0.0.2  Added many tags
//         Added last action logic
//         Added last surname logic and sort
//2.0.0.3  fixes were NAME value are replaced in EDUC tag
//         Adds support from 500 individuals to 9999 individuals in a GED
//2.0.1.0  Adds header & base option and the CORP, VERS, FILE, CHAR, FORM Tags
//2.0.1.1  Better family reports
//2.0.1.2  fixes help
//         Adds support for more families and longer data fields 
//2.1.0.0  No longer beta, Adds better command line feedback.
//2.1.0.1  Adds HEAD Tags [1 SOUR] [2 NAME] [1 DATE] [2 TIME] [1 FILE]
//         Adds INDI Tags [1 OBJE] [2 FILE]
//         Adds INDI Tags [1 CREM] [2 PLAC]
//         Version system
//2.1.0.2  Fixes 0 HEAD -> 1 SOUR is reported as CORP
//2.1.1.0  Creates better HTML output 

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

char *r_version="2.1.0.2";

int print_head(void);
void print_report(void);
void print_tail(void);
int comp_string (char *name1, char *name2);

char filename[50];
char last_action[4];
char last_surname[110];
char indi[6];
char indi_name[9999][110];
char indi_surname[9999][110];
char disp_surname[9999][110];
char indi_sex[9999];
char seximage[9999][110];
char indi_occu[9999][110];
char indi_note[9999][110];
char indi_educ[9999][110];
char indi_reli[9999][110];
char indi_birt_date[9999][110];
char indi_birt_plac[9999][110];
char indi_birt_note[9999][110];
char indi_deat_date[9999][110];
char indi_deat_plac[9999][110];
char indi_deat_note[9999][110];
char indi_buri_date[9999][110];
char indi_buri_plac[9999][110];
char indi_buri_note[9999][110];
char indi_crem_plac[9999][110];
char indi_chan_date[9999][110];
int indi_r=0;
char fam[6];
char fam_husb[1900][110];
char fam_wife[1900][110];
char fam_chil[1900][110];
char fam_marr_date[1900][110];
char fam_marr_plac[1900][110];
char fam_marr_note[1900][110];
char fam_div_date[1900][110];
char fam_div_plac[1900][110];
char fam_div_note[1900][110];
int fam_r=0;
int number_of_names=0;
int lines_of_data=0;
int id_pointer=0;
int x=0, y=0;
char temp[110];
char option='a';
FILE *fp;

//////////////////////////////////////////
/// int main()
/////////////////////////////////////////
int main(int argc, char **argv)
{
  if(argc==2 || argc==3){
    if(argv[1][0]=='-'){
      option=argv[1][1];
    }
    else{
       printf("GEDCOM Report: Sorry, no flag specified.\nFor more information type: gedreport2 -h\n");
       return(0);
    }
  }
  else{
     printf("GEDCOM Report: Sorry, no flag specified.\nFor more information type: gedreport2 -h\n");
     return(0);
  }
  
  if(argc==3){
    sprintf(filename,"%s",argv[2]);
  }

  if(option =='h' ){
     printf("\nGEDCOM Report %s (c)2003 Michael Gibson mike@mrgibson.com\n",r_version);
     printf("gedreport2 -i|-f|-s|-h|-t gedfile >htmlfile\n");
     printf("-i Individuals Report\n-f Family Report\n-s Surname Report\n-h This help\n");
     printf("-t Header and base support\n");
     return(0);
  }

  if(option != 'i' && option != 'h' && option != 'f' && option != 's' && option != 't'){
     printf("GEDCOM Report: Sorry, no valid flag specified.\nFor more information type: gedreport2 -h\n");
     return(0);
  }

  if((fp=fopen(filename,"r"))==NULL ){
     printf("GEDCOM Report: Sorry, no file found. \n");
     exit(0);
  }

  printf("<html>\n");
  printf("<head>\n");
  printf("<title> GEDCOM Report on %s </title>\n",filename);
  printf("</head>\n");
  printf("<body bgcolor=#FFFFFF>\n");
  print_head();
  print_report();
  print_tail();
  printf("</body>\n");
  printf("</html>\n");
  return(0);
}

///////////////////////////////////////////////////////////////
/// print_head()
///////////////////////////////////////////////////////////////

int print_head(void)
{
  if(option=='s')
    printf("<img src=gedbase.gif align=center /> <b>Surname Report</b><br />\n");

  if(option=='f')
    printf("<b><font color=009500>Family Report</font></b><br />\n");

  if(option=='i')
    printf("<b><font color=009500>Individuals Report</font></b><br />\n");

  if(option=='t')
    printf("<img src=gedbase.gif align=center /> <b><font color=009500>Header and Base Report</font></b>\n");

  return(0);

}

//////////////////////////////////////////
/// print_report()
/////////////////////////////////////////
void print_report()
{

///// Catches 
///// 0 INDI -> 1 NAME 
///// and 
///// 0 SUBM -> 1 NAME
do{
  fgets(temp,80,fp);
  if(temp[0]=='1' && temp[2]=='N' && temp[3]=='A'){     ///1 NAME
     number_of_names++;
     for(x=7;x<80;x++){temp[x-7]=temp[x];} 
     strcpy(indi_name[indi_r],temp);
     if(option=='i'||option=='t'){
        printf("<br /><img src=gedline1.gif align=center /> Name = %s\n",indi_name[indi_r]);
     }
     if(option=='s'){
        strcat(indi_name[indi_r],"!");
        x=0;
        do{
           indi_name[indi_r][x];
           x++;
        }while(indi_name[indi_r][x] != '/' && indi_name[indi_r][x] != '!');
        indi_name[indi_r][x] = ' ';
        y=0;
        do{
           indi_surname[indi_r][y]=indi_name[indi_r][x];
           x++;
           y++;
        }while(indi_name[indi_r][x] != '/' && indi_name[indi_r][x] != '\0');
        strcat(indi_surname[indi_r],"<br />\n");
     }	
  }

///// Catches
///// 0 FAM -> 1 HUSB
  if(temp[0]=='1' && temp[2]=='H' && temp[3]=='U'){   ///1 HUSB
      for(x=8;x<80;x++){
         if(temp[x]=='@' ||temp[x]=='I') temp[x]=' ';}
      sprintf(fam_husb[fam_r],"%c%c%c%c",temp[9],temp[10],temp[11],temp[12]);
      id_pointer=atoi(fam_husb[fam_r]);
      if(option=='f') printf("<br /><img src=gedline1.gif align=center /> Husband = <b>%s</b> (%s - %s)",indi_name[id_pointer],indi_birt_date[id_pointer],indi_deat_date[id_pointer]);
  }

///// Catches
///// 0 FAM -> 1 WIFE
  if(temp[0]=='1' && temp[2]=='W' && temp[3]=='I'){ //1 WIFE
      for(x=8;x<80;x++){
         if(temp[x]=='@' ||temp[x]=='I') temp[x]=' ';}
      sprintf(fam_wife[fam_r],"%c%c%c%c",temp[9],temp[10],temp[11],temp[12]);
      id_pointer=atoi(fam_wife[fam_r]);
      if(option=='f') printf("<br /><img src=gedline1.gif align=center /> Wife = <b>%s</b> (%s - %s)",indi_name[id_pointer],indi_birt_date[id_pointer],indi_deat_date[id_pointer]);
  }

///// Catches
///// 0 FAM -> 1 CHIL
  if(temp[0]=='1' && temp[2]=='C' && temp[3]=='H' && temp[4]=='I'){ //1 CHIL
      for(x=8;x<80;x++){
         if(temp[x]=='@' ||temp[x]=='I') temp[x]=' ';}
      sprintf(fam_chil[fam_r],"%c%c%c%c",temp[9],temp[10],temp[11],temp[12]);
      id_pointer=atoi(fam_chil[fam_r]);
      if(option=='f') printf("<br /><img src=gedline2.gif align=center /> Child = %s <b>%s</b> (%s - %s)",seximage[id_pointer],indi_name[id_pointer],indi_birt_date[id_pointer],indi_deat_date[id_pointer]);
  }

///// Catches
///// 0 INDI -> 1 NOTE
  if(temp[0]=='1' && temp[2]=='N' && temp[3]=='O'){ //1 NOTE
     for(x=7;x<80;x++){temp[x-7]=temp[x];}
     strcpy(indi_note[indi_r],temp);
     if(option=='i') printf("<br /><img src=gedline1.gif align=center /> Notes = %s",indi_note[indi_r]);
  }


//// Catches
//// 0 HEAD -> 1 SOUR 
  if(temp[0]=='1' && temp[2]=='S' && temp[3]=='O' && temp[4]== 'R'){ //1 SOUR
     for(x=7;x<80;x++){temp[x-7]=temp[x];}
     if(option=='t') printf("<br /><img src=gedline1.gif align=center /> Source = %s",temp);
  }

//// Catches
//// 0 HEAD -> 1 SOUR -> 2 CORP
  if(temp[0]=='2' && temp[2]=='C' && temp[3]=='O' && temp[4]== 'R'){ //2 CORP
     for(x=7;x<80;x++){temp[x-7]=temp[x];}
     if(option=='t') printf("<br /><img src=gedline1.gif align=center /> CORP = %s",temp);
  }

//// Catches
//// 0 HEAD -> 1 GEDC -> 2 FORM
  if(temp[0]=='2' && temp[2]=='F' && temp[3]=='O' && temp[4]== 'R'){ //2 FORM
     for(x=7;x<80;x++){temp[x-7]=temp[x];}
     if(option=='t') printf("<br /><img src=gedline1.gif align=center /> Form = %s",temp);
  }

//// Catches
//// 0 HEAD -> 1 SOUR -> 2 VERS
//// 0 HEAD -> 1 GEDC -> 2 VERS
  if(temp[0]=='2' && temp[2]=='V' && temp[3]=='E'){ //2 VERS
     for(x=7;x<80;x++){temp[x-7]=temp[x];}
     if(option=='t') printf("<br /><img src=gedline1.gif align=center /> Version = %s",temp);
  }

///// Catches
///// 0 HEAD -> 1 SOUR -> 2 NAME
  if(temp[0]=='2' && temp[2]=='N' && temp[3]=='A'){ //2 NAME
     for(x=7;x<80;x++){temp[x-7]=temp[x];}
     if(option=='t') printf("<br /><img src=gedline1.gif align=center /> GEDCOM Source Name = %s",temp);
  }


///// Catches
///// 0 HEAD -> 1 DATE
  if(temp[0]=='1' && temp[2]=='D' && temp[3]=='A'){ //1 DATE
     for(x=7;x<80;x++){temp[x-7]=temp[x];}
     if(option=='t') printf("<br /><img src=gedline1.gif align=center /> GEDCOM Date = %s",temp);
  }

///// Catches
///// 0 HEAD -> 1 DATE -> 2 TIME
  if(temp[0]=='2' && temp[2]=='T' && temp[3]=='I'){ //2 TIME
     for(x=7;x<80;x++){temp[x-7]=temp[x];}
     if(option=='t') printf("<br /><img src=gedline1.gif align=center /> GEDCOM Time = %s",temp);
  }


//// Catches
//// 0 HEAD -> 1 FILE
  if(temp[0]=='1' && temp[2]=='F' && temp[3]=='I'){ //1 FILE
     for(x=7;x<80;x++){temp[x-7]=temp[x];}
     if(option=='t') printf("<br /><img src=gedline1.gif align=center /> GEDCOM FILE = %s",temp);
  }

//// Catches
//// 0 HEAD -> 1 CHAR
  if(temp[0]=='1' && temp[2]=='C' && temp[3]=='H' && temp[4]=='A' && temp[5]=='R'){ //1 CHAR
     for(x=7;x<80;x++){temp[x-7]=temp[x];}
     if(option=='t') printf("<br /><img src=gedline1.gif align=center /> Character Set = %s",temp);
  }

//// Catches
//// 0 INDI -> 1 BIRT -> 2 NOTE
//// 0 INDI -> 1 DEAT -> 2 NOTE
//// 0 INDI -> 1 BURI -> 2 NOTE 
  if(temp[0]=='2' && temp[2]=='N' && temp[3]=='O'){ //2 NOTE
     for(x=7;x<80;x++){temp[x-7]=temp[x];}
     if(last_action[0]=='B' && last_action[1]=='I'){
       strcpy(indi_birt_note[indi_r],temp);
       if(option=='i') printf("<br /><img src=gedline1.gif align=center /> Birth Notes = %s",indi_birt_note[indi_r]);
     }
     if(last_action[0]=='D' && last_action[1]=='E'){
       strcpy(indi_deat_note[indi_r],temp);
       if(option=='i') printf("<br /><img src=gedline1.gif align=center /> Death Notes = %s",indi_deat_note[indi_r]);
     }
     if(last_action[0]=='B' && last_action[1]=='U'){
       strcpy(indi_buri_note[indi_r],temp);
       if(option=='i') printf("<br /><img src=gedline1.gif align=center /> Burial Notes = %s",indi_buri_note[indi_r]);
     }
  }

//// Catches
//// 0 INDI -> 1 BIRT -> 2 DATE
//// 0 INDI -> 1 DEAT -> 2 DATE
//// 0 INDI -> 1 BURI -> 2 DATE
//// 0 INDI -> 1 CHAN -> 2 DATE
//// 0 FAM  -> 1 MARR -> 2 DATE
//// 0 FAM  -> 1 DIV  -> 2 DATE
  if(temp[0]=='2' && temp[2]=='D' && temp[3]=='A'){ //2 DATE
     for(x=7;x<80;x++){temp[x-7]=temp[x];}
     if(last_action[0]=='B' && last_action[1]=='I'){
       strcpy(indi_birt_date[indi_r],temp);
       if(option=='i') printf("<br /><img src=gedline1.gif align=center /> Birth Date  = %s",indi_birt_date[indi_r]);
     }
     if(last_action[0]=='D' && last_action[1]=='E'){
       strcpy(indi_deat_date[indi_r],temp);
       if(option=='i') printf("<br /><img src=gedline1.gif align=center />  Death Date  = %s",indi_deat_date[indi_r]);
     }
     if(last_action[0]=='B' && last_action[1]=='U'){
       strcpy(indi_buri_date[indi_r],temp);
       if(option=='i') printf("<br /><img src=gedline1.gif align=center />  Burial Notes = %s",indi_buri_date[indi_r]);
     }
     if(last_action[0]=='C' && last_action[1]=='H'){
       strcpy(indi_chan_date[indi_r],temp);
       if(option=='i') printf("<br /><img src=gedline1.gif align=center />  Record Last Edited = %s",indi_chan_date[indi_r]);
     }
     if(last_action[0]=='M' && last_action[1]=='A'){
       strcpy(fam_marr_date[fam_r],temp);
       if(option=='f') printf("<br /><img src=gedline1.gif align=center /> Marriage Date = %s",fam_marr_date[fam_r]);
     }
      if(last_action[0]=='D' && last_action[1]=='I'){
       strcpy(fam_div_date[fam_r],temp);
       if(option=='f') printf("<br /><img src=gedline1.gif align=center /> Divorce Date = %s",fam_div_date[fam_r]);
     }
  }
///// Catches
///// 0 INDI -> 1 BIRT -> 2 PLAC
///// 0 INDI -> 1 DEAT -> 2 PLAC
///// 0 INDI -> 1 BURI -> 2 PLAC
///// 0 INDI -> 1 CREM -> 2 PLAC
///// 0 FAM  -> 1 MARR -> 2 PLAC
///// 0 FAM  -> 1 DIV  -> 2 PLAC
  if(temp[0]=='2' && temp[2]=='P' && temp[3]=='L'){ //2 PLAC
     for(x=7;x<80;x++){temp[x-7]=temp[x];}
     if(last_action[0]=='B' && last_action[1]=='I'){
       strcpy(indi_birt_plac[indi_r],temp);
       if(option=='i') printf("<br /><img src=gedline1.gif align=center />  Birth Place = %s",indi_birt_plac[indi_r]);
     }
     if(last_action[0]=='D' && last_action[1]=='E'){
       strcpy(indi_deat_plac[indi_r],temp);
       if(option=='i') printf("<br /><img src=gedline1.gif align=center />  Death Place = %s",indi_deat_plac[indi_r]);
     }
     if(last_action[0]=='B' && last_action[1]=='U'){
       strcpy(indi_buri_plac[indi_r],temp);
       if(option=='i') printf("<br /><img src=gedline1.gif align=center />  Burial Place = %s",indi_buri_plac[indi_r]);
     }
     if(last_action[0]=='C' && last_action[1]=='R'){
       strcpy(indi_crem_plac[indi_r],temp);
       if(option=='i') printf("<br /><img src=gedline1.gif align=center />  Cremation Place = %s",indi_crem_plac[indi_r]);
     }
     if(last_action[0]=='M' && last_action[1]=='A'){
       strcpy(fam_marr_plac[fam_r],temp);
       if(option=='f') printf("<br /><img src=gedline1.gif align=center />  Marriage Place = %s",fam_marr_plac[fam_r]);
     }
      if(last_action[0]=='D' && last_action[1]=='I'){
       strcpy(fam_div_plac[fam_r],temp);
       if(option=='f') printf("<br /><img src=gedline1.gif align=center />  Divorce Place = %s",fam_div_plac[fam_r]);
     }
  }

///// Catches
///// 0 INDI -> 1 OBJE -> 2 FILE
  if(temp[0]=='2' && temp[2]=='F' && temp[3]=='I'){ //2 FILE
     for(x=7;x<80;x++){temp[x-7]=temp[x];}
     if(last_action[0]=='O' && last_action[1]=='B'){
       strcpy(indi_birt_plac[indi_r],temp);
       if(option=='i') printf("<br /><img src=gedline1.gif align=center />  Media = <a href=%s><img src=photo.gif border=0 /></a>",indi_birt_plac[indi_r]);
     }
  }




///// Catches
///// 0 INDI -> 1 EDUC
  if(temp[0]=='1' && temp[2]=='E' && temp[3]=='D'){ //1 EDUC
     for(x=7;x<80;x++){temp[x-7]=temp[x];}
     strcpy(indi_educ[indi_r],temp);
     if(option=='i') printf("<br /><img src=gedline1.gif align=center />  Education = %s",indi_educ[indi_r]);
  }

///// Catches
///// 0 INDI -> 1 OCCU
  if(temp[0]=='1' && temp[2]=='O' && temp[3]=='C'){ //1 OCCU
     for(x=7;x<80;x++){temp[x-7]=temp[x];}
     strcpy(indi_occu[indi_r],temp);
     if(option=='i') printf("<br /><img src=gedline1.gif align=center /> Occupation = %s",indi_occu[indi_r]);
  }



  if(temp[0]=='1' && temp[2]=='R' && temp[3]=='E'){ //1 RELI
     for(x=7;x<80;x++){temp[x-7]=temp[x];}
     strcpy(indi_reli[indi_r],temp);
     if(option=='i') printf("<br /><img src=gedline1.gif align=center /> Religion = %s",indi_reli[indi_r]);
  }


  if(temp[0]=='1' && temp[2]=='S' && temp[3]=='E'){ //1 SEX
     indi_sex[indi_r]=temp[6];
     if(option=='i') printf("<br /><img src=gedline1.gif align=center /> Sex = %c \n",indi_sex[indi_r]);
     if(indi_sex[indi_r]=='M')strcpy(seximage[indi_r],"<img src=male.gif>");
     if(indi_sex[indi_r]=='F')strcpy(seximage[indi_r],"<img src=female.gif>");
  }

  if(temp[0]=='1' && temp[2]=='B' && temp[3]=='I'){ //1 BIRT
     strcpy(last_action,"BIRT");
  }    

  if(temp[0]=='1' && temp[2]=='D' && temp[3]=='E' && temp[4] =='A'){ //1 DEAT
     strcpy(last_action,"DEAT");
  }

  if(temp[0]=='1' && temp[2]=='B' && temp[3]=='U' && temp[4] =='R'){ //1 BURI 
     strcpy(last_action,"BURI");
  }

  if(temp[0]=='1' && temp[2]=='C' && temp[3]=='R' && temp[4] =='E'){ //1 CREM
     strcpy(last_action,"CREM");
  }

  if(temp[0]=='1' && temp[2]=='C' && temp[3]=='H' && temp[4] =='A' && temp[5]=='N'){ //1 CHAN
     strcpy(last_action,"CHAN");
  }


  if(temp[0]=='1' && temp[2]=='O' && temp[3]=='B' && temp[4] =='J' && temp[5]=='E'){ //1 OBJE
     strcpy(last_action,"OBJE");
  }


  if(temp[0]=='1' && temp[2]=='M' && temp[3]=='A' && temp[4] =='R'){ //1 MARR
     strcpy(last_action,"MARR");
  }

  if(temp[0]=='1' && temp[2]=='D' && temp[3]=='I' && temp[4] =='V'){ //1 DIV 
     strcpy(last_action,"DIV");
  }

  if(temp[0]=='0' && temp[2]=='@' && temp[3]=='I'){ //Individual 0 level start of record
      for(x=5;x<80;x++) if(temp[x]=='@' ||temp[x]=='I') temp[x]=' ';
      sprintf(indi,"%c%c%c%c",temp[4],temp[5],temp[6],temp[7]);
      if(option=='i') printf("<br /><br /><img src=gedbase.gif align=center /> Record = %s\n",indi);
      indi_r=atoi(indi);
  }

  if(temp[0]=='0' && temp[2]=='@' && temp[3]=='F'){ //Family 0 level start of record
      for(x=5;x<80;x++) if(temp[x]=='@' ||temp[x]=='F') temp[x]=' ';
      sprintf(fam,"%c%c%c%c",temp[4],temp[5],temp[6],temp[7]);
      if(option=='f') printf("<br /><br /><img src=gedbase.gif align=center /> Family Record = %s\n",fam);
      fam_r=atoi(fam);
  }
 lines_of_data++; 
}while(temp[0] !='0' || temp[2] !='T');
		
fclose(fp);

if(option=='s'){
  printf("<b><font color=009900><img src=gedline1.gif align=center />");
  printf(" Number of Individuals in GED  = %d</font></b><br />\n",number_of_names);
  printf("<b><font color=009900><img src=gedline1.gif align=center />"); 
  printf(" Lines of Data in GED = %d</font></b><br />\n",lines_of_data);
  number_of_names=number_of_names-1;
  for(x=0;x<number_of_names;x++) strcpy(disp_surname[x],indi_surname[x]);
  qsort(disp_surname,number_of_names,110,comp_string);
  for(x=0;x<number_of_names;x++){
    if((strcmp(disp_surname[x],"<br />"))!=0 && (strcmp(disp_surname[x]," <br />"))!=0 &&(strcmp(disp_surname[x],last_surname))!=0){
       printf("<img src=gedline2.gif align=center />%s",disp_surname[x]);
       strcpy(last_surname,disp_surname[x]);
     }
  }
}

}
///////////////////////////////////////
/// comp_string()
///////////////////////////////////////
int comp_string (char *name1, char *name2)
{
  int i;
  i = strcmp (name1, name2);
  return i;
}

///////////////////////////////////////////////////////////
// print_tail()
//////////////////////////////////////////////////////////
void print_tail()
{
printf("<hr><h5>Report Created with MrGibson.COM GEDCOM REPORT Version %s (c)2003\n",r_version);
printf("</h5>\n");
}
