//////////////////////////////
// tree.c
// written by Michael Gibson
// released under the GPla
// copyright 2003-2007
//////////////////////////////

#include <stdio.h>
#include <string.h>
#include "GDXlib.h"

int no_father=1; //no father is default until shown there is
int no_mother=1; //no mother is default until shown there is

char filename[50];
char indi[6];
char indi_name[9999][110];
int indi_r=0;
char fam[6];
char fam_husb[1900][110];
char fam_wife[1900][110];
char fam_chil[1900][110];
int fam_r=0;
int lines_of_data=0;
int id_pointer=0;
int x=0;
char temp[99];

int person;

int family_father[9999];
int family_mother[9999];

char displayfather1[80];
int familyfather1_id;

char displaymother1[80];
int familymother1_id;

char displayfather2[80];
char displaymother2[80];

char displayfather3[80];
char displaymother3[80];


FILE *fp7;



/////////////////////////////////////////////////////
/////call remote add father and mother 
/////////////////////////////////////////////////////
static void add_parents(void)
{
  char sysstring[60];

  sprintf(sysstring,"./gedadd_parent %d %s '%s' &",person,filename,indi_name[person]);
  //printf("%s \n",sysstring);
  system(sysstring);
}

/////////////////////////////////////////////////////
///// quit app
/////////////////////////////////////////////////////
static void destroy(void)
{
    gdx_closewindow();
}

//////////////////////////////////////////////////////
// read_ged
/////////////////////////////////////////////////////
void read_ged(void){

fp7=fopen(filename,"r");

do{
  fgets(temp,90,fp7);                                              /// read a record

  if(temp[0]=='1' && temp[2]=='N' && temp[3]=='A'){                /// 1 NAME
     for(x=7;x<80;x++){
        if(temp[x]=='/')temp[x]=' ';
        temp[x-7]=temp[x];
     }
     temp[strlen(temp)-1]='\0';                                    /// clean up fgets 
     strcpy(indi_name[indi_r],temp);                               /// copy the name into the array of indi's
     
  }

  if(temp[0]=='1' && temp[2]=='H' && temp[3]=='U'){                /// 1 HUSB
      for(x=8;x<80;x++){
         if(temp[x]=='@' ||temp[x]=='I') temp[x]=' ';}             /// remove characters that are not numbers
      sprintf(fam_husb[fam_r],"%c%c%c%c",temp[9],temp[10],temp[11],temp[12]);
      family_father[fam_r]=atoi(fam_husb[fam_r]);                  /// store the father id to the family id
  }


  if(temp[0]=='1' && temp[2]=='W' && temp[3]=='I'){                /// 1 WIFE
      for(x=8;x<80;x++){
         if(temp[x]=='@' ||temp[x]=='I') temp[x]=' ';}
      sprintf(fam_wife[fam_r],"%c%c%c%c",temp[9],temp[10],temp[11],temp[12]);
      family_mother[fam_r]=atoi(fam_wife[fam_r]);
  }

  if(temp[0]=='1' && temp[2]=='C' && temp[3]=='H' && temp[4]=='I'){ //1 CHIL
      for(x=8;x<80;x++){
         if(temp[x]=='@' ||temp[x]=='I') temp[x]=' ';}
      sprintf(fam_chil[fam_r],"%c%c%c%c",temp[9],temp[10],temp[11],temp[12]);
      id_pointer=atoi(fam_chil[fam_r]);
      if(id_pointer == person){
         strcpy(displayfather1,indi_name[family_father[fam_r]]);
         //printf("father lenght = %d",strlen(displayfather1));
         familyfather1_id=family_father[fam_r];
         strcpy(displaymother1,indi_name[family_mother[fam_r]]);
         familymother1_id=family_mother[fam_r];
         no_father=0;
         no_mother=0;
      }

      if(id_pointer == familyfather1_id){
         strcpy(displayfather2,indi_name[family_father[fam_r]]);
         strcpy(displaymother2,indi_name[family_mother[fam_r]]);
      }
      if(id_pointer == familymother1_id){
         strcpy(displayfather3,indi_name[family_father[fam_r]]);
         strcpy(displaymother3,indi_name[family_mother[fam_r]]);
      }
  }


  if(temp[0]=='0' && temp[2]=='@' && temp[3]=='I'){ //Individual 0 level start of record
      for(x=5;x<80;x++) if(temp[x]=='@' ||temp[x]=='I') temp[x]=' ';
      sprintf(indi,"%c%c%c%c",temp[4],temp[5],temp[6],temp[7]);
      //printf("Record = %s\n",indi);
      indi_r=atoi(indi);
  }

  if(temp[0]=='0' && temp[2]=='@' && temp[3]=='F'){ //Family 0 level start of record
      for(x=5;x<80;x++) if(temp[x]=='@' ||temp[x]=='F') temp[x]=' ';
      sprintf(fam,"%c%c%c%c",temp[4],temp[5],temp[6],temp[7]);
      //printf("Family Record = %s\n",fam);
      fam_r=atoi(fam);
  }

  lines_of_data++;
}while(temp[0] !='0' || temp[2] !='T');

fclose(fp7);

}
////////////////////////////////////////////////////
//
///////////////////////////////////////////////////

int main(int argc, char **argv){

  int button_01,button_02,button_03,button_04;
  int label0,label1,label2;
  int label15,label3,label4,label5,label6,label7,label8,label9;

  char toplabel[100];
  
  strcpy(filename,argv[1]);

  person=atoi(argv[2]);

  //printf("person = '%d' file = '%s'\n",person,filename);

  read_ged();

  //printf("Start GUI\n");

  x_open();

  gdx_window("GEDCOM Tree",600,400);
  gdx_setwindowbg("bbg.xpm",1);
  //printf("window painted\n");

  gdx_image(0,134,"tree.xpm");
  gdx_image(1,150,"white.xpm");
  gdx_image(10,220,"white.xpm");
  gdx_image(40,165,"white.xpm");
  gdx_image(140,150,"white.xpm");
  gdx_image(40,300,"white.xpm");
  gdx_image(140,300,"white.xpm");

  button_01 = gdx_imagebutton(5,25,"close.xpm",destroy);

  sprintf(toplabel,"Tree view for : %s ",indi_name[person]);
  label0 = gdx_label(toplabel,50,35,1);
  gdx_setlabelbg("white.xpm",1,label0);

  sprintf(toplabel,"ID : %d ",person);
  label1 = gdx_label(toplabel,50,60,1);
  gdx_setlabelbg("white.xpm",1,label1);



  //anchor person
  label2 = gdx_label(indi_name[person],50,250,1);
  gdx_setlabelbg("white.xpm",1,label2);

  //father
  //gdx_hseparator(100, 195, 65);
  //gdx_vseparator(100, 195, 30);
  label3=  gdx_label(displayfather1,170,200,1);
  gdx_setlabelbg("white.xpm",1,label3);

  if(no_father==1 && no_mother==1){
     button_03 = gdx_imagebutton(5,50,"addparents.xpm",add_parents);
     label15 = gdx_label("Add parent info for root individual.", 50,85,1);
     gdx_setlabelbg("yellow.xpm",1,label15);
  }
 
  //mother
  //gdx_hseparator(100, 295, 65);
  //gdx_vseparator(100, 265, 30);
  label4=gdx_label(displaymother1,170,300,1);;
  gdx_setlabelbg("white.xpm",1,label4);

  //father2
  //gdx_hseparator(220, 170, 65);
  //gdx_vseparator(220, 170, 15);
  label5=gdx_label(displayfather2,290,175,1);
  gdx_setlabelbg("white.xpm",1,label5);

  //mother2
  //gdx_hseparator(220, 220, 65);
  //gdx_vseparator(220, 205, 15);
  label6=gdx_label(displaymother2,290,225,1);
  gdx_setlabelbg("white.xpm",1,label6);

  //father3
  //gdx_hseparator(220, 270, 65);
  //gdx_vseparator(220, 270, 15);
  label7=gdx_label(displayfather3,290,275,1);
  gdx_setlabelbg("white.xpm",1,label7);
  //mother3
  //gdx_hseparator(220, 320, 65);
  //gdx_vseparator(220, 305, 15);
  label8=gdx_label(displaymother3,290,325,1);
  gdx_setlabelbg("white.xpm",1,label8);
  gdx_main();

  x_close();

}


////

/////



